## rabbitmq-server 2.6.1-1

=== debian/changelog ===
rabbitmq-server (2.6.1-1) unstable; urgency=low

  * New upstream release

 -- John Leuner <jewel@debian.org>  Tue, 27 Sep 2011 17:53:57 +0200

rabbitmq-server (2.5.0-1) unstable; urgency=low

  * New upstream release 

 -- John Leuner <jewel@debian.org>  Thu, 16 Jun 2011 09:55:40 +0200

rabbitmq-server (2.4.1-1) unstable; urgency=low

  * New upstream release

 -- John Leuner <jewel@debian.org>  Sat, 09 Apr 2011 09:34:06 +0200

rabbitmq-server (2.4.0-1) unstable; urgency=low

  * New upstream release

 -- John Leuner <jewel@debian.org>  Wed, 23 Mar 2011 21:11:17 +0200

rabbitmq-server (2.3.1-1) unstable; urgency=low

  * New upstream release, closes: #611253

 -- John Leuner <jewel@debian.org>  Sat, 05 Feb 2011 10:21:16 +0200

rabbitmq-server (2.2.0-1) unstable; urgency=low

  * New upstream release

 -- John Leuner <jewel@debian.org>  Thu, 02 Dec 2010 20:41:53 +0200

rabbitmq-server (2.1.0-1) unstable; urgency=low

  * New upstream release

 -- John Leuner <jewel@debian.org>  Mon, 27 Sep 2010 20:28:06 +0200

rabbitmq-server (2.0.0-2) unstable; urgency=low

  * Fix various scripts that were not updated correctly in
    - the 2.0.0-1 package, closes: #594724

 -- John Leuner <jewel@debian.org>  Thu, 02 Sep 2010 18:01:37 +0200

rabbitmq-server (2.0.0-1) unstable; urgency=low

  * New upstream release

 -- John Leuner <jewel@debian.org>  Sat, 28 Aug 2010 11:21:48 +0200

rabbitmq-server (1.8.1-1) unstable; urgency=low

  * New upstream release

 -- John Leuner <jewel@debian.org>  Sun, 01 Aug 2010 15:47:46 +0200

rabbitmq-server (1.8.0-1) unstable; urgency=low

  * New upstream release

 -- John Leuner <jewel@debian.org>  Thu, 24 Jun 2010 18:43:04 +0200

rabbitmq-server (1.7.0-3) unstable; urgency=low

  * Add missing entries in rabbitmq-server.init

 -- John Leuner <jewel@debian.org>  Sun, 25 Oct 2009 10:21:25 +0200

rabbitmq-server (1.7.0-2) unstable; urgency=low

  * moved debian/init.d to rabbitmq-server.init
  * included fixes to rabbitmq-script-wrapper

 -- John Leuner <jewel@debian.org>  Wed, 14 Oct 2009 12:23:52 +0200

rabbitmq-server (1.7.0-1) unstable; urgency=low

  * New upstream release

 -- John Leuner <jewel@debian.org>  Sat, 10 Oct 2009 13:28:39 +0200

rabbitmq-server (1.6.0-1) unstable; urgency=low

  * New upstream release

 -- John Leuner <jewel@debian.org>  Sat, 20 Jun 2009 12:22:17 +0200

rabbitmq-server (1.5.5-3) unstable; urgency=low

  *  debian/control: Reduce Erlang dependencies to just
     erlang-mnesia and erlang-os-mon, closes: #532867

 -- John Leuner <jewel@debian.org>  Tue, 16 Jun 2009 14:15:20 +0200

rabbitmq-server (1.5.5-2) unstable; urgency=low

  * Include updates to debian package by rabbit team:
    - quiet log rotate 
    - update build-depends and depends for new erlang packages
    - debian/watch file
    - add rabbitmq-script-wrapper
    - update init.d scripts
    - clean /etc/rabbitmq in postrm

 -- John Leuner <jewel@debian.org>  Wed, 03 Jun 2009 12:23:50 +0200

rabbitmq-server (1.5.5-1) unstable; urgency=low

  * New upstream release

 -- John Leuner <jewel@debian.org>  Tue, 02 Jun 2009 12:53:32 +0200

rabbitmq-server (1.5.4-4) unstable; urgency=low

  * Add new dependency on erlang-os-mon to work with new erlang packages in
    debian

 -- John Leuner <jewel@debian.org>  Mon, 11 May 2009 21:20:04 +0200

rabbitmq-server (1.5.4-3) unstable; urgency=low

  * Previous partial upload failed

 -- John Leuner <jewel@debian.org>  Fri, 10 Apr 2009 20:25:51 +0200

rabbitmq-server (1.5.4-2) unstable; urgency=low

  * Fix incorrect changed-by field in .changes file

 -- John Leuner <jewel@debian.org>  Fri, 10 Apr 2009 19:40:04 +0200

rabbitmq-server (1.5.4-1) unstable; urgency=low

  * New upstream release

 -- John Leuner <jewel@debian.org>  Fri, 10 Apr 2009 17:54:21 +0200

rabbitmq-server (1.5.0-5) unstable; urgency=low

  * Include the full license for amqp-0.8.json in debian/copyright

 -- John Leuner <jewel@debian.org>  Fri, 27 Feb 2009 16:16:54 +0200

rabbitmq-server (1.5.0-4) unstable; urgency=low

  * Clarify and explicitly list the license and copyright for
    codegen/amqp-0.8.json
	
  * Explicitly list the authors and copyright for the rest of the codebase
    at the top of debian/copyright
	
  * Clarify the copyright of the files in src/tcp_* . The rabbitmq authors have
    confirmed that they are the original authors of this code and that the
    files at http://code.google.com/p/cacherl/ were taken without their
    knowledge from the rabbitmq project. (Comparing the commit dates in version
    control shows that cacherl is newer)

 -- John Leuner <jewel@debian.org>  Wed, 25 Feb 2009 13:10:15 +0200

rabbitmq-server (1.5.0-3) unstable; urgency=low

  * Previous changelog entry had an incorrect Maintainer name

 -- John Leuner <jewel@debian.org>  Wed, 28 Jan 2009 16:45:33 +0200

rabbitmq-server (1.5.0-2) unstable; urgency=low

  * Reupload package to unstable. Mistakenly uploaded to testing last time, closes: #507902

 -- John Leuner <jewel@debian.org>  Mon, 19 Jan 2009 17:38:43 +0200

rabbitmq-server (1.5.0-1) testing; urgency=low

  * New Upstream Release
  * First Debian upload, closes: #507902

 -- John Leuner <jewel@debian.org>  Wed, 17 Dec 2008 18:23:47 +0000

=== debian/control ===
Source: rabbitmq-server
Section: net
Priority: extra
Maintainer: RabbitMQ Team <packaging@rabbitmq.com>
Build-Depends: cdbs, debhelper (>= 5), erlang-dev, python-simplejson, xmlto, xsltproc
Standards-Version: 3.8.0

Package: rabbitmq-server
Architecture: all
Depends: erlang-nox (>= 1:12.b.3), adduser, logrotate, ${misc:Depends}
Description: An AMQP server written in Erlang
 RabbitMQ is an implementation of AMQP, the emerging standard for high
 performance enterprise messaging. The RabbitMQ server is a robust and
 scalable implementation of an AMQP broker.
Homepage: http://www.rabbitmq.com/

## rabbitmq-server 2.6.1-2

=== Makefile ===
TMPDIR ?= /tmp

RABBITMQ_NODENAME ?= rabbit
RABBITMQ_SERVER_START_ARGS ?=
RABBITMQ_MNESIA_DIR ?= $(TMPDIR)/rabbitmq-$(RABBITMQ_NODENAME)-mnesia
RABBITMQ_PLUGINS_EXPAND_DIR ?= $(TMPDIR)/rabbitmq-$(RABBITMQ_NODENAME)-plugins-scratch
RABBITMQ_LOG_BASE ?= $(TMPDIR)

DEPS_FILE=deps.mk
SOURCE_DIR=src
EBIN_DIR=ebin
INCLUDE_DIR=include
DOCS_DIR=docs
INCLUDES=$(wildcard $(INCLUDE_DIR)/*.hrl) $(INCLUDE_DIR)/rabbit_framing.hrl
SOURCES=$(wildcard $(SOURCE_DIR)/*.erl) $(SOURCE_DIR)/rabbit_framing_amqp_0_9_1.erl $(SOURCE_DIR)/rabbit_framing_amqp_0_8.erl $(USAGES_ERL)
BEAM_TARGETS=$(patsubst $(SOURCE_DIR)/%.erl, $(EBIN_DIR)/%.beam, $(SOURCES))
TARGETS=$(EBIN_DIR)/rabbit.app $(INCLUDE_DIR)/rabbit_framing.hrl $(BEAM_TARGETS)
WEB_URL=http://www.rabbitmq.com/
MANPAGES=$(patsubst %.xml, %.gz, $(wildcard $(DOCS_DIR)/*.[0-9].xml))
WEB_MANPAGES=$(patsubst %.xml, %.man.xml, $(wildcard $(DOCS_DIR)/*.[0-9].xml) $(DOCS_DIR)/rabbitmq-service.xml)
USAGES_XML=$(DOCS_DIR)/rabbitmqctl.1.xml
USAGES_ERL=$(foreach XML, $(USAGES_XML), $(call usage_xml_to_erl, $(XML)))
QC_MODULES := rabbit_backing_queue_qc
QC_TRIALS ?= 100

ifeq ($(shell python -c 'import simplejson' 2>/dev/null && echo yes),yes)
PYTHON=python
else
ifeq ($(shell python2.6 -c 'import simplejson' 2>/dev/null && echo yes),yes)
PYTHON=python2.6
else
ifeq ($(shell python2.5 -c 'import simplejson' 2>/dev/null && echo yes),yes)
PYTHON=python2.5
else
# Hmm. Missing simplejson?
PYTHON=python
endif
endif
endif

BASIC_PLT=basic.plt
RABBIT_PLT=rabbit.plt

ifndef USE_SPECS
# our type specs rely on features and bug fixes in dialyzer that are
# only available in R14B03 upwards (R14B03 is erts 5.8.4)
USE_SPECS:=$(shell erl -noshell -eval 'io:format([list_to_integer(X) || X <- string:tokens(erlang:system_info(version), ".")] >= [5,8,4]), halt().')
endif

ifndef USE_PROPER_QC
# PropEr needs to be installed for property checking
# http://proper.softlab.ntua.gr/
USE_PROPER_QC:=$(shell erl -noshell -eval 'io:format({module, proper} =:= code:ensure_loaded(proper)), halt().')
endif

#other args: +native +"{hipe,[o3,verbose]}" -Ddebug=true +debug_info +no_strict_record_tests
ERLC_OPTS=-I $(INCLUDE_DIR) -o $(EBIN_DIR) -Wall -v +debug_info $(call boolean_macro,$(USE_SPECS),use_specs) $(call boolean_macro,$(USE_PROPER_QC),use_proper_qc)

VERSION=0.0.0
TARBALL_NAME=rabbitmq-server-$(VERSION)
TARGET_SRC_DIR=dist/$(TARBALL_NAME)

SIBLING_CODEGEN_DIR=../rabbitmq-codegen/
AMQP_CODEGEN_DIR=$(shell [ -d $(SIBLING_CODEGEN_DIR) ] && echo $(SIBLING_CODEGEN_DIR) || echo codegen)
AMQP_SPEC_JSON_FILES_0_9_1=$(AMQP_CODEGEN_DIR)/amqp-rabbitmq-0.9.1.json
AMQP_SPEC_JSON_FILES_0_8=$(AMQP_CODEGEN_DIR)/amqp-rabbitmq-0.8.json

ERL_CALL=erl_call -sname $(RABBITMQ_NODENAME) -e

ERL_EBIN=erl -noinput -pa $(EBIN_DIR)

define usage_xml_to_erl
  $(subst __,_,$(patsubst $(DOCS_DIR)/rabbitmq%.1.xml, $(SOURCE_DIR)/rabbit_%_usage.erl, $(subst -,_,$(1))))
endef

define usage_dep
  $(call usage_xml_to_erl, $(1)): $(1) $(DOCS_DIR)/usage.xsl
endef

define boolean_macro
$(if $(filter true,$(1)),-D$(2))
endef

ifneq "$(SBIN_DIR)" ""
ifneq "$(TARGET_DIR)" ""
SCRIPTS_REL_PATH=$(shell ./calculate-relative $(TARGET_DIR)/sbin $(SBIN_DIR))
endif
endif

# Versions prior to this are not supported
NEED_MAKE := 3.80
ifneq "$(NEED_MAKE)" "$(firstword $(sort $(NEED_MAKE) $(MAKE_VERSION)))"
$(error Versions of make prior to $(NEED_MAKE) are not supported)
endif

# .DEFAULT_GOAL introduced in 3.81
DEFAULT_GOAL_MAKE := 3.81
ifneq "$(DEFAULT_GOAL_MAKE)" "$(firstword $(sort $(DEFAULT_GOAL_MAKE) $(MAKE_VERSION)))"
.DEFAULT_GOAL=all
endif

all: $(TARGETS)

$(DEPS_FILE): $(SOURCES) $(INCLUDES)
	rm -f $@
	echo $(subst : ,:,$(foreach FILE,$^,$(FILE):)) | escript generate_deps $@ $(EBIN_DIR)

$(EBIN_DIR)/rabbit.app: $(EBIN_DIR)/rabbit_app.in $(SOURCES) generate_app
	escript generate_app $< $@ $(SOURCE_DIR)

$(EBIN_DIR)/%.beam: $(SOURCE_DIR)/%.erl | $(DEPS_FILE)
	erlc $(ERLC_OPTS) -pa $(EBIN_DIR) $<

$(INCLUDE_DIR)/rabbit_framing.hrl: codegen.py $(AMQP_CODEGEN_DIR)/amqp_codegen.py $(AMQP_SPEC_JSON_FILES_0_9_1) $(AMQP_SPEC_JSON_FILES_0_8)
	$(PYTHON) codegen.py --ignore-conflicts header $(AMQP_SPEC_JSON_FILES_0_9_1) $(AMQP_SPEC_JSON_FILES_0_8) $@

$(SOURCE_DIR)/rabbit_framing_amqp_0_9_1.erl: codegen.py $(AMQP_CODEGEN_DIR)/amqp_codegen.py $(AMQP_SPEC_JSON_FILES_0_9_1)
	$(PYTHON) codegen.py body $(AMQP_SPEC_JSON_FILES_0_9_1) $@

$(SOURCE_DIR)/rabbit_framing_amqp_0_8.erl: codegen.py $(AMQP_CODEGEN_DIR)/amqp_codegen.py $(AMQP_SPEC_JSON_FILES_0_8)
	$(PYTHON) codegen.py body $(AMQP_SPEC_JSON_FILES_0_8) $@

dialyze: $(BEAM_TARGETS) $(BASIC_PLT)
	dialyzer --plt $(BASIC_PLT) --no_native --fullpath \
	  -Wrace_conditions $(BEAM_TARGETS)

# rabbit.plt is used by rabbitmq-erlang-client's dialyze make target
create-plt: $(RABBIT_PLT)

$(RABBIT_PLT): $(BEAM_TARGETS) $(BASIC_PLT)
	dialyzer --plt $(BASIC_PLT) --output_plt $@ --no_native \
	  --add_to_plt $(BEAM_TARGETS)

$(BASIC_PLT): $(BEAM_TARGETS)
	if [ -f $@ ]; then \
	    touch $@; \
	else \
	    dialyzer --output_plt $@ --build_plt \
		--apps erts kernel stdlib compiler sasl os_mon mnesia tools \
		  public_key crypto ssl; \
	fi

clean:
	rm -f $(EBIN_DIR)/*.beam
	rm -f $(EBIN_DIR)/rabbit.app $(EBIN_DIR)/rabbit.boot $(EBIN_DIR)/rabbit.script $(EBIN_DIR)/rabbit.rel
	rm -f $(INCLUDE_DIR)/rabbit_framing.hrl $(SOURCE_DIR)/rabbit_framing_amqp_*.erl codegen.pyc
	rm -f $(DOCS_DIR)/*.[0-9].gz $(DOCS_DIR)/*.man.xml $(DOCS_DIR)/*.erl $(USAGES_ERL)
	rm -f $(RABBIT_PLT)
	rm -f $(DEPS_FILE)

cleandb:
	rm -rf $(RABBITMQ_MNESIA_DIR)/*

############ various tasks to interact with RabbitMQ ###################

BASIC_SCRIPT_ENVIRONMENT_SETTINGS=\
	RABBITMQ_NODE_IP_ADDRESS="$(RABBITMQ_NODE_IP_ADDRESS)" \
	RABBITMQ_NODE_PORT="$(RABBITMQ_NODE_PORT)" \
	RABBITMQ_LOG_BASE="$(RABBITMQ_LOG_BASE)" \
	RABBITMQ_MNESIA_DIR="$(RABBITMQ_MNESIA_DIR)" \
	RABBITMQ_PLUGINS_EXPAND_DIR="$(RABBITMQ_PLUGINS_EXPAND_DIR)"

run: all
	$(BASIC_SCRIPT_ENVIRONMENT_SETTINGS) \
		RABBITMQ_ALLOW_INPUT=true \
		RABBITMQ_SERVER_START_ARGS="$(RABBITMQ_SERVER_START_ARGS)" \
		./scripts/rabbitmq-server

run-node: all
	$(BASIC_SCRIPT_ENVIRONMENT_SETTINGS) \
		RABBITMQ_NODE_ONLY=true \
		RABBITMQ_ALLOW_INPUT=true \
		RABBITMQ_SERVER_START_ARGS="$(RABBITMQ_SERVER_START_ARGS)" \
		./scripts/rabbitmq-server

run-tests: all
	OUT=$$(echo "rabbit_tests:all_tests()." | $(ERL_CALL)) ; \
	  echo $$OUT ; echo $$OUT | grep '^{ok, passed}$$' > /dev/null

run-qc: all
	$(foreach MOD,$(QC_MODULES),./quickcheck $(RABBITMQ_NODENAME) $(MOD) $(QC_TRIALS))

start-background-node:
	$(BASIC_SCRIPT_ENVIRONMENT_SETTINGS) \
		RABBITMQ_NODE_ONLY=true \
		RABBITMQ_SERVER_START_ARGS="$(RABBITMQ_SERVER_START_ARGS) -detached" \
		./scripts/rabbitmq-server; sleep 1

start-rabbit-on-node: all
	echo "rabbit:start()." | $(ERL_CALL)

stop-rabbit-on-node: all
	echo "rabbit:stop()." | $(ERL_CALL)

set-memory-alarm: all
	echo "alarm_handler:set_alarm({{vm_memory_high_watermark, node()}, []})." | \
	$(ERL_CALL)

clear-memory-alarm: all
	echo "alarm_handler:clear_alarm({vm_memory_high_watermark, node()})." | \
	$(ERL_CALL)

stop-node:
	-$(ERL_CALL) -q

# code coverage will be created for subdirectory "ebin" of COVER_DIR
COVER_DIR=.

start-cover: all
	echo "rabbit_misc:start_cover([\"rabbit\", \"hare\"])." | $(ERL_CALL)
	echo "rabbit_misc:enable_cover([\"$(COVER_DIR)\"])." | $(ERL_CALL)

start-secondary-cover: all
	echo "rabbit_misc:start_cover([\"hare\"])." | $(ERL_CALL)

stop-cover: all
	echo "rabbit_misc:report_cover(), cover:stop()." | $(ERL_CALL)
	cat cover/summary.txt

########################################################################

srcdist: distclean
	mkdir -p $(TARGET_SRC_DIR)/codegen
	cp -r ebin src include LICENSE LICENSE-MPL-RabbitMQ $(TARGET_SRC_DIR)
	cp INSTALL.in $(TARGET_SRC_DIR)/INSTALL
	elinks -dump -no-references -no-numbering $(WEB_URL)install.html \
		>> $(TARGET_SRC_DIR)/INSTALL
	cp README.in $(TARGET_SRC_DIR)/README
	elinks -dump -no-references -no-numbering $(WEB_URL)build-server.html \
		>> $(TARGET_SRC_DIR)/README
	sed -i.save 's/%%VSN%%/$(VERSION)/' $(TARGET_SRC_DIR)/ebin/rabbit_app.in && rm -f $(TARGET_SRC_DIR)/ebin/rabbit_app.in.save

	cp -r $(AMQP_CODEGEN_DIR)/* $(TARGET_SRC_DIR)/codegen/
	cp codegen.py Makefile generate_app generate_deps calculate-relative $(TARGET_SRC_DIR)

	cp -r scripts $(TARGET_SRC_DIR)
	cp -r $(DOCS_DIR) $(TARGET_SRC_DIR)
	chmod 0755 $(TARGET_SRC_DIR)/scripts/*

	(cd dist; tar -zcf $(TARBALL_NAME).tar.gz $(TARBALL_NAME))
	(cd dist; zip -q -r $(TARBALL_NAME).zip $(TARBALL_NAME))
	rm -rf $(TARGET_SRC_DIR)

distclean: clean
	$(MAKE) -C $(AMQP_CODEGEN_DIR) distclean
	rm -rf dist
	find . -regex '.*\(~\|#\|\.swp\|\.dump\)' -exec rm {} \;

# xmlto can not read from standard input, so we mess with a tmp file.
%.gz: %.xml $(DOCS_DIR)/examples-to-end.xsl
	xmlto --version | grep -E '^xmlto version 0\.0\.([0-9]|1[1-8])$$' >/dev/null || opt='--stringparam man.indent.verbatims=0' ; \
	    xsltproc --novalid $(DOCS_DIR)/examples-to-end.xsl $< > $<.tmp && \
	    xmlto -o $(DOCS_DIR) $$opt man $<.tmp && \
	    gzip -f $(DOCS_DIR)/`basename $< .xml`
	rm -f $<.tmp

# Use tmp files rather than a pipeline so that we get meaningful errors
# Do not fold the cp into previous line, it's there to stop the file being
# generated but empty if we fail
$(SOURCE_DIR)/%_usage.erl:
	xsltproc --novalid --stringparam modulename "`basename $@ .erl`" \
		$(DOCS_DIR)/usage.xsl $< > $@.tmp
	sed -e 's/"/\\"/g' -e 's/%QUOTE%/"/g' $@.tmp > $@.tmp2
	fold -s $@.tmp2 > $@.tmp3
	mv $@.tmp3 $@
	rm $@.tmp $@.tmp2

# We rename the file before xmlto sees it since xmlto will use the name of
# the file to make internal links.
%.man.xml: %.xml $(DOCS_DIR)/html-to-website-xml.xsl
	cp $< `basename $< .xml`.xml && \
		xmlto xhtml-nochunks `basename $< .xml`.xml ; rm `basename $< .xml`.xml
	cat `basename $< .xml`.html | \
	    xsltproc --novalid $(DOCS_DIR)/remove-namespaces.xsl - | \
		xsltproc --novalid --stringparam original `basename $<` $(DOCS_DIR)/html-to-website-xml.xsl - | \
		xmllint --format - > $@
	rm `basename $< .xml`.html

docs_all: $(MANPAGES) $(WEB_MANPAGES)

install: install_bin install_docs

install_bin: all install_dirs
	cp -r ebin include LICENSE LICENSE-MPL-RabbitMQ INSTALL $(TARGET_DIR)

	chmod 0755 scripts/*
	for script in rabbitmq-env rabbitmq-server rabbitmqctl; do \
		cp scripts/$$script $(TARGET_DIR)/sbin; \
		[ -e $(SBIN_DIR)/$$script ] || ln -s $(SCRIPTS_REL_PATH)/$$script $(SBIN_DIR)/$$script; \
	done
	mkdir -p $(TARGET_DIR)/plugins
	echo Put your .ez plugin files in this directory. > $(TARGET_DIR)/plugins/README

install_docs: docs_all install_dirs
	for section in 1 5; do \
		mkdir -p $(MAN_DIR)/man$$section; \
		for manpage in $(DOCS_DIR)/*.$$section.gz; do \
			cp $$manpage $(MAN_DIR)/man$$section; \
		done; \
	done

install_dirs:
	@ OK=true && \
	  { [ -n "$(TARGET_DIR)" ] || { echo "Please set TARGET_DIR."; OK=false; }; } && \
	  { [ -n "$(SBIN_DIR)" ] || { echo "Please set SBIN_DIR."; OK=false; }; } && \
	  { [ -n "$(MAN_DIR)" ] || { echo "Please set MAN_DIR."; OK=false; }; } && $$OK

	mkdir -p $(TARGET_DIR)/sbin
	mkdir -p $(SBIN_DIR)
	mkdir -p $(MAN_DIR)

$(foreach XML,$(USAGES_XML),$(eval $(call usage_dep, $(XML))))

# Note that all targets which depend on clean must have clean in their
# name.  Also any target that doesn't depend on clean should not have
# clean in its name, unless you know that you don't need any of the
# automatic dependency generation for that target (eg cleandb).

# We want to load the dep file if *any* target *doesn't* contain
# "clean" - i.e. if removing all clean-like targets leaves something

ifeq "$(MAKECMDGOALS)" ""
TESTABLEGOALS:=$(.DEFAULT_GOAL)
else
TESTABLEGOALS:=$(MAKECMDGOALS)
endif

ifneq "$(strip $(patsubst clean%,,$(patsubst %clean,,$(TESTABLEGOALS))))" ""
-include $(DEPS_FILE)
endif

.PHONY: run-qc

=== debian/changelog ===
rabbitmq-server (2.6.1-2) unstable; urgency=low

  * Add DM-Upload-Allowed flag to control file to allow Maintainer uploads

 -- John Leuner <jewel@debian.org>  Mon, 19 Mar 2012 21:13:54 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,10 @@
 Section: net
 Priority: extra
 Maintainer: RabbitMQ Team <packaging@rabbitmq.com>
+Uploaders: John Leuner <jewel@debian.org>, Emile Joubert <emile@rabbitmq.com>
 Build-Depends: cdbs, debhelper (>= 5), erlang-dev, python-simplejson, xmlto, xsltproc
 Standards-Version: 3.8.0
+DM-Upload-Allowed: yes
 
 Package: rabbitmq-server
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

RABBIT_LIB=$(DEB_DESTDIR)usr/lib/rabbitmq/lib/rabbitmq_server-$(DEB_UPSTREAM_VERSION)/
RABBIT_BIN=$(DEB_DESTDIR)usr/lib/rabbitmq/bin/

DEB_MAKE_INSTALL_TARGET := install TARGET_DIR=$(RABBIT_LIB) SBIN_DIR=$(RABBIT_BIN) MAN_DIR=$(DEB_DESTDIR)usr/share/man/
DEB_MAKE_CLEAN_TARGET:= distclean

DOCDIR=$(DEB_DESTDIR)usr/share/doc/rabbitmq-server/

install/rabbitmq-server::
	mkdir -p $(DOCDIR)
	rm $(RABBIT_LIB)LICENSE* $(RABBIT_LIB)INSTALL*
	for script in rabbitmqctl rabbitmq-server; do \
		install -p -D -m 0755 debian/rabbitmq-script-wrapper $(DEB_DESTDIR)usr/sbin/$$script; \
	done
	sed -e 's|@RABBIT_LIB@|/usr/lib/rabbitmq/lib/rabbitmq_server-$(DEB_UPSTREAM_VERSION)|g' <debian/postrm.in >debian/postrm
	install -p -D -m 0755 debian/rabbitmq-server.ocf $(DEB_DESTDIR)usr/lib/ocf/resource.d/rabbitmq/rabbitmq-server

## rabbitmq-server 2.7.1

=== Makefile ===
--- 
+++ 
@@ -14,11 +14,11 @@
 INCLUDES=$(wildcard $(INCLUDE_DIR)/*.hrl) $(INCLUDE_DIR)/rabbit_framing.hrl
 SOURCES=$(wildcard $(SOURCE_DIR)/*.erl) $(SOURCE_DIR)/rabbit_framing_amqp_0_9_1.erl $(SOURCE_DIR)/rabbit_framing_amqp_0_8.erl $(USAGES_ERL)
 BEAM_TARGETS=$(patsubst $(SOURCE_DIR)/%.erl, $(EBIN_DIR)/%.beam, $(SOURCES))
-TARGETS=$(EBIN_DIR)/rabbit.app $(INCLUDE_DIR)/rabbit_framing.hrl $(BEAM_TARGETS)
+TARGETS=$(EBIN_DIR)/rabbit.app $(INCLUDE_DIR)/rabbit_framing.hrl $(BEAM_TARGETS) plugins
 WEB_URL=http://www.rabbitmq.com/
 MANPAGES=$(patsubst %.xml, %.gz, $(wildcard $(DOCS_DIR)/*.[0-9].xml))
 WEB_MANPAGES=$(patsubst %.xml, %.man.xml, $(wildcard $(DOCS_DIR)/*.[0-9].xml) $(DOCS_DIR)/rabbitmq-service.xml)
-USAGES_XML=$(DOCS_DIR)/rabbitmqctl.1.xml
+USAGES_XML=$(DOCS_DIR)/rabbitmqctl.1.xml $(DOCS_DIR)/rabbitmq-plugins.1.xml
 USAGES_ERL=$(foreach XML, $(USAGES_XML), $(call usage_xml_to_erl, $(XML)))
 QC_MODULES := rabbit_backing_queue_qc
 QC_TRIALS ?= 100
@@ -57,6 +57,8 @@
 ERLC_OPTS=-I $(INCLUDE_DIR) -o $(EBIN_DIR) -Wall -v +debug_info $(call boolean_macro,$(USE_SPECS),use_specs) $(call boolean_macro,$(USE_PROPER_QC),use_proper_qc)
 
 VERSION=0.0.0
+PLUGINS_SRC_DIR?=$(shell [ -d "plugins-src" ] && echo "plugins-src" || echo )
+PLUGINS_DIR=plugins
 TARBALL_NAME=rabbitmq-server-$(VERSION)
 TARGET_SRC_DIR=dist/$(TARBALL_NAME)
 
@@ -100,6 +102,19 @@
 endif
 
 all: $(TARGETS)
+
+.PHONY: plugins
+ifneq "$(PLUGINS_SRC_DIR)" ""
+plugins:
+	[ -d "$(PLUGINS_SRC_DIR)/rabbitmq-server" ] || ln -s "$(CURDIR)" "$(PLUGINS_SRC_DIR)/rabbitmq-server"
+	mkdir -p $(PLUGINS_DIR)
+	PLUGINS_SRC_DIR="" $(MAKE) -C "$(PLUGINS_SRC_DIR)" plugins-dist PLUGINS_DIST_DIR="$(CURDIR)/$(PLUGINS_DIR)" VERSION=$(VERSION)
+	echo "Put your EZs here and use rabbitmq-plugins to enable them." > $(PLUGINS_DIR)/README
+	rm -f $(PLUGINS_DIR)/rabbit_common*.ez
+else
+plugins:
+# Not building plugins
+endif
 
 $(DEPS_FILE): $(SOURCES) $(INCLUDES)
 	rm -f $@
@@ -143,6 +158,8 @@
 clean:
 	rm -f $(EBIN_DIR)/*.beam
 	rm -f $(EBIN_DIR)/rabbit.app $(EBIN_DIR)/rabbit.boot $(EBIN_DIR)/rabbit.script $(EBIN_DIR)/rabbit.rel
+	rm -f $(PLUGINS_DIR)/*.ez
+	[ -d "$(PLUGINS_SRC_DIR)" ] && PLUGINS_SRC_DIR="" PRESERVE_CLONE_DIR=1 make -C $(PLUGINS_SRC_DIR) clean || true
 	rm -f $(INCLUDE_DIR)/rabbit_framing.hrl $(SOURCE_DIR)/rabbit_framing_amqp_*.erl codegen.pyc
 	rm -f $(DOCS_DIR)/*.[0-9].gz $(DOCS_DIR)/*.man.xml $(DOCS_DIR)/*.erl $(USAGES_ERL)
 	rm -f $(RABBIT_PLT)
@@ -173,6 +190,12 @@
 		RABBITMQ_SERVER_START_ARGS="$(RABBITMQ_SERVER_START_ARGS)" \
 		./scripts/rabbitmq-server
 
+run-background-node: all
+	$(BASIC_SCRIPT_ENVIRONMENT_SETTINGS) \
+		RABBITMQ_NODE_ONLY=true \
+		RABBITMQ_SERVER_START_ARGS="$(RABBITMQ_SERVER_START_ARGS)" \
+		./scripts/rabbitmq-server
+
 run-tests: all
 	OUT=$$(echo "rabbit_tests:all_tests()." | $(ERL_CALL)) ; \
 	  echo $$OUT ; echo $$OUT | grep '^{ok, passed}$$' > /dev/null
@@ -180,14 +203,15 @@
 run-qc: all
 	$(foreach MOD,$(QC_MODULES),./quickcheck $(RABBITMQ_NODENAME) $(MOD) $(QC_TRIALS))
 
-start-background-node:
-	$(BASIC_SCRIPT_ENVIRONMENT_SETTINGS) \
-		RABBITMQ_NODE_ONLY=true \
-		RABBITMQ_SERVER_START_ARGS="$(RABBITMQ_SERVER_START_ARGS) -detached" \
-		./scripts/rabbitmq-server; sleep 1
+start-background-node: all
+	-rm -f $(RABBITMQ_MNESIA_DIR).pid
+	mkdir -p $(RABBITMQ_MNESIA_DIR)
+	setsid sh -c "$(MAKE) run-background-node > $(RABBITMQ_MNESIA_DIR)/startup_log 2> $(RABBITMQ_MNESIA_DIR)/startup_err" &
+	sleep 1
 
 start-rabbit-on-node: all
 	echo "rabbit:start()." | $(ERL_CALL)
+	./scripts/rabbitmqctl -n $(RABBITMQ_NODENAME) wait $(RABBITMQ_MNESIA_DIR).pid
 
 stop-rabbit-on-node: all
 	echo "rabbit:stop()." | $(ERL_CALL)
@@ -221,13 +245,7 @@
 
 srcdist: distclean
 	mkdir -p $(TARGET_SRC_DIR)/codegen
-	cp -r ebin src include LICENSE LICENSE-MPL-RabbitMQ $(TARGET_SRC_DIR)
-	cp INSTALL.in $(TARGET_SRC_DIR)/INSTALL
-	elinks -dump -no-references -no-numbering $(WEB_URL)install.html \
-		>> $(TARGET_SRC_DIR)/INSTALL
-	cp README.in $(TARGET_SRC_DIR)/README
-	elinks -dump -no-references -no-numbering $(WEB_URL)build-server.html \
-		>> $(TARGET_SRC_DIR)/README
+	cp -r ebin src include LICENSE LICENSE-MPL-RabbitMQ INSTALL README $(TARGET_SRC_DIR)
 	sed -i.save 's/%%VSN%%/$(VERSION)/' $(TARGET_SRC_DIR)/ebin/rabbit_app.in && rm -f $(TARGET_SRC_DIR)/ebin/rabbit_app.in.save
 
 	cp -r $(AMQP_CODEGEN_DIR)/* $(TARGET_SRC_DIR)/codegen/
@@ -237,7 +255,20 @@
 	cp -r $(DOCS_DIR) $(TARGET_SRC_DIR)
 	chmod 0755 $(TARGET_SRC_DIR)/scripts/*
 
-	(cd dist; tar -zcf $(TARBALL_NAME).tar.gz $(TARBALL_NAME))
+ifneq "$(PLUGINS_SRC_DIR)" ""
+	cp -r $(PLUGINS_SRC_DIR) $(TARGET_SRC_DIR)/plugins-src
+	rm $(TARGET_SRC_DIR)/LICENSE
+	cat packaging/common/LICENSE.head >> $(TARGET_SRC_DIR)/LICENSE
+	cat $(AMQP_CODEGEN_DIR)/license_info >> $(TARGET_SRC_DIR)/LICENSE
+	find $(PLUGINS_SRC_DIR)/licensing -name "license_info_*" -exec cat '{}' >> $(TARGET_SRC_DIR)/LICENSE \;
+	cat packaging/common/LICENSE.tail >> $(TARGET_SRC_DIR)/LICENSE
+	find $(PLUGINS_SRC_DIR)/licensing -name "LICENSE-*" -exec cp '{}' $(TARGET_SRC_DIR) \;
+	rm -rf $(TARGET_SRC_DIR)/licensing
+else
+	@echo No plugins source distribution found
+endif
+
+	(cd dist; tar -zchf $(TARBALL_NAME).tar.gz $(TARBALL_NAME))
 	(cd dist; zip -q -r $(TARBALL_NAME).zip $(TARBALL_NAME))
 	rm -rf $(TARGET_SRC_DIR)
 
@@ -281,52 +312,15 @@
 install: install_bin install_docs
 
 install_bin: all install_dirs
-	cp -r ebin include LICENSE LICENSE-MPL-RabbitMQ INSTALL $(TARGET_DIR)
+	cp -r ebin include LICENSE* INSTALL $(TARGET_DIR)
 
 	chmod 0755 scripts/*
-	for script in rabbitmq-env rabbitmq-server rabbitmqctl; do \
+	for script in rabbitmq-env rabbitmq-server rabbitmqctl rabbitmq-plugins; do \
 		cp scripts/$$script $(TARGET_DIR)/sbin; \
 		[ -e $(SBIN_DIR)/$$script ] || ln -s $(SCRIPTS_REL_PATH)/$$script $(SBIN_DIR)/$$script; \
 	done
-	mkdir -p $(TARGET_DIR)/plugins
-	echo Put your .ez plugin files in this directory. > $(TARGET_DIR)/plugins/README
+
+	mkdir -p $(TARGET_DIR)/$(PLUGINS_DIR)
+	[ -d "$(PLUGINS_DIR)" ] && cp $(PLUGINS_DIR)/*.ez $(PLUGINS_DIR)/README $(TARGET_DIR)/$(PLUGINS_DIR) || true
 
 install_docs: docs_all install_dirs
-	for section in 1 5; do \
-		mkdir -p $(MAN_DIR)/man$$section; \
-		for manpage in $(DOCS_DIR)/*.$$section.gz; do \
-			cp $$manpage $(MAN_DIR)/man$$section; \
-		done; \
-	done
-
-install_dirs:
-	@ OK=true && \
-	  { [ -n "$(TARGET_DIR)" ] || { echo "Please set TARGET_DIR."; OK=false; }; } && \
-	  { [ -n "$(SBIN_DIR)" ] || { echo "Please set SBIN_DIR."; OK=false; }; } && \
-	  { [ -n "$(MAN_DIR)" ] || { echo "Please set MAN_DIR."; OK=false; }; } && $$OK
-
-	mkdir -p $(TARGET_DIR)/sbin
-	mkdir -p $(SBIN_DIR)
-	mkdir -p $(MAN_DIR)
-
-$(foreach XML,$(USAGES_XML),$(eval $(call usage_dep, $(XML))))
-
-# Note that all targets which depend on clean must have clean in their
-# name.  Also any target that doesn't depend on clean should not have
-# clean in its name, unless you know that you don't need any of the
-# automatic dependency generation for that target (eg cleandb).
-
-# We want to load the dep file if *any* target *doesn't* contain
-# "clean" - i.e. if removing all clean-like targets leaves something
-
-ifeq "$(MAKECMDGOALS)" ""
-TESTABLEGOALS:=$(.DEFAULT_GOAL)
-else
-TESTABLEGOALS:=$(MAKECMDGOALS)
-endif
-
-ifneq "$(strip $(patsubst clean%,,$(patsubst %clean,,$(TESTABLEGOALS))))" ""
--include $(DEPS_FILE)
-endif
-
-.PHONY: run-qc

=== plugins-src/Makefile ===
.PHONY: default
default:
	@echo No default target && false

PACKAGE_REPOS:=\
    eldap-wrapper \
    erlando \
    erlang-rfc4627-wrapper \
    hstcp \
    mochiweb-wrapper \
    rabbitmq-auth-backend-ldap \
    rabbitmq-auth-mechanism-ssl \
    rabbitmq-consistent-hash-exchange \
    rabbitmq-erlang-client \
    rabbitmq-external-exchange \
    rabbitmq-federation \
    rabbitmq-ha-test \
    rabbitmq-jsonrpc \
    rabbitmq-jsonrpc-channel \
    rabbitmq-jsonrpc-channel-examples \
    rabbitmq-management \
    rabbitmq-management-agent \
    rabbitmq-management-visualiser \
    rabbitmq-metronome \
    rabbitmq-mochiweb \
    rabbitmq-shovel \
    rabbitmq-shovel-management \
    rabbitmq-stomp \
    rabbitmq-toke \
    rabbitmq-tracing \
    toke \
    webmachine-wrapper

REPOS:=rabbitmq-server rabbitmq-codegen $(PACKAGE_REPOS)

BRANCH:=default

HG_CORE_REPOBASE:=$(shell dirname `hg paths default 2>/dev/null` 2>/dev/null)
ifndef HG_CORE_REPOBASE
HG_CORE_REPOBASE:=http://hg.rabbitmq.com/
endif

VERSION:=0.0.0

#----------------------------------

all:
	$(MAKE) -f all-packages.mk all-packages VERSION=$(VERSION)

test:
	$(MAKE) -f all-packages.mk test-all-packages VERSION=$(VERSION)

release:
	$(MAKE) -f all-packages.mk all-releasable VERSION=$(VERSION)

clean:
	$(MAKE) -f all-packages.mk clean-all-packages

check-xref:
	$(MAKE) -f all-packages.mk check-xref-packages

plugins-dist: release
	rm -rf $(PLUGINS_DIST_DIR)
	mkdir -p $(PLUGINS_DIST_DIR)
	$(MAKE) -f all-packages.mk copy-releasable VERSION=$(VERSION) $(PLUGINS_DIST_DIR)=$(PLUGINS_DIST_DIR)

plugins-srcdist:
	rm -rf $(PLUGINS_SRC_DIST_DIR)
	mkdir -p $(PLUGINS_SRC_DIST_DIR)/licensing

	rsync -a --exclude '.hg*' rabbitmq-erlang-client $(PLUGINS_SRC_DIST_DIR)/
	touch $(PLUGINS_SRC_DIST_DIR)/rabbitmq-erlang-client/.srcdist_done

	rsync -a --exclude '.hg*' rabbitmq-server $(PLUGINS_SRC_DIST_DIR)/
	touch $(PLUGINS_SRC_DIST_DIR)/rabbitmq-server/.srcdist_done

	$(MAKE) -f all-packages.mk copy-srcdist VERSION=$(VERSION) $(PLUGINS_SRC_DIST_DIR)=$(PLUGINS_SRC_DIST_DIR)
	cp Makefile *.mk generate* $(PLUGINS_SRC_DIST_DIR)/
	echo "This is the released version of rabbitmq-public-umbrella. \
You can clone the full version with: hg clone http://hg.rabbitmq.com/rabbitmq-public-umbrella" > $(PLUGINS_SRC_DIST_DIR)/README

	PRESERVE_CLONE_DIR=1 make -C $(PLUGINS_SRC_DIST_DIR) clean
	rm -rf $(PLUGINS_SRC_DIST_DIR)/rabbitmq-server

#----------------------------------
# Convenience aliases

.PHONY: co
co: checkout

.PHONY: ci
ci: checkin

.PHONY: up
up: update

.PHONY: st
st: status

.PHONY: up_c
up_c: named_update

#----------------------------------

$(REPOS):
	hg clone $(HG_CORE_REPOBASE)/$@

.PHONY: checkout
checkout: $(REPOS)

#----------------------------------
# Subrepository management


# $(1) is the target
# $(2) is the target dependency. Can use % to get current REPO
# $(3) is the target body. Can use % to get current REPO
define repo_target

.PHONY: $(1)
$(1): $(2)
	$(3)

endef

# $(1) is the list of repos
# $(2) is the suffix
# $(3) is the target dependency. Can use % to get current REPO
# $(4) is the target body. Can use % to get current REPO
define repo_targets
$(foreach REPO,$(1),$(call repo_target,$(REPO)+$(2),\
	$(patsubst %,$(3),$(REPO)),$(patsubst %,$(4),$(REPO))))
endef

# Do not allow status to fork with -j otherwise output will be garbled
.PHONY: status
status: checkout
	$(foreach DIR,. $(REPOS), \
		(cd $(DIR); OUT=$$(hg st -mad); \
		if \[ ! -z "$$OUT" \]; then echo "\n$(DIR):\n$$OUT"; fi) &&) true

.PHONY: pull
pull: $(foreach DIR,. $(REPOS),$(DIR)+pull)

$(eval $(call repo_targets,. $(REPOS),pull,| %,(cd % && hg pull)))

.PHONY: update
update: $(foreach DIR,. $(REPOS),$(DIR)+update)

$(eval $(call repo_targets,. $(REPOS),update,%+pull,(cd % && hg up)))

.PHONY: named_update
named_update: $(foreach DIR,. $(REPOS),$(DIR)+named_update)

$(eval $(call repo_targets,. $(REPOS),named_update,%+pull,\
	(cd % && hg up -C $(BRANCH))))

.PHONY: tag
tag: $(foreach DIR,. $(PACKAGE_REPOS),$(DIR)+tag)

$(eval $(call repo_targets,. $(PACKAGE_REPOS),tag,| %,(cd % && hg tag $(TAG))))

.PHONY: push
push: $(foreach DIR,. $(REPOS),$(DIR)+push)

$(eval $(call repo_targets,. $(REPOS),push,| %,(cd % && hg push -f)))

.PHONY: checkin
checkin: $(foreach DIR,. $(REPOS),$(DIR)+checkin)

$(eval $(call repo_targets,. $(REPOS),checkin,| %,(cd % && hg ci)))

=== plugins-src/rabbitmq-erlang-client/Makefile ===
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
# The Original Code is RabbitMQ.
#
# The Initial Developer of the Original Code is VMware, Inc.
# Copyright (c) 2007-2011 VMware, Inc.  All rights reserved.
#

VERSION=0.0.0

SOURCE_PACKAGE_DIR=$(PACKAGE)-$(VERSION)-src
SOURCE_PACKAGE_TAR_GZ=$(SOURCE_PACKAGE_DIR).tar.gz

BROKER_HEADERS=$(wildcard $(BROKER_DIR)/$(INCLUDE_DIR)/*.hrl)
BROKER_SOURCES=$(wildcard $(BROKER_DIR)/$(SOURCE_DIR)/*.erl)
BROKER_DEPS=$(BROKER_HEADERS) $(BROKER_SOURCES)

INFILES=$(shell find . -name '*.app.in')
INTARGETS=$(patsubst %.in, %, $(INFILES))

include common.mk

run_in_broker: compile $(BROKER_DEPS) $(EBIN_DIR)/$(PACKAGE).app
	$(MAKE) RABBITMQ_SERVER_START_ARGS='$(PA_LOAD_PATH)' -C $(BROKER_DIR) run

clean: common_clean
	rm -f $(INTARGETS)
	rm -rf $(DIST_DIR)

distribution: documentation source_tarball package

%.app: %.app.in $(SOURCES) $(BROKER_DIR)/generate_app
	escript  $(BROKER_DIR)/generate_app $< $@ $(SOURCE_DIR)
	sed -i.save 's/%%VSN%%/$(VERSION)/' $@ && rm $@.save

###############################################################################
##  Dialyzer
###############################################################################

RABBIT_PLT=$(BROKER_DIR)/rabbit.plt

dialyze: $(RABBIT_PLT) $(TARGETS)
	dialyzer --plt $(RABBIT_PLT) --no_native -Wrace_conditions $(TARGETS)

.PHONY: $(RABBIT_PLT)
$(RABBIT_PLT):
	$(MAKE) -C $(BROKER_DIR) create-plt

###############################################################################
##  Documentation
###############################################################################

documentation: $(DOC_DIR)/index.html

$(DOC_DIR)/overview.edoc: $(SOURCE_DIR)/overview.edoc.in
	mkdir -p $(DOC_DIR)
	sed -e 's:%%VERSION%%:$(VERSION):g' < $< > $@

$(DOC_DIR)/index.html: $(DEPS_DIR)/$(COMMON_PACKAGE_DIR) $(DOC_DIR)/overview.edoc $(SOURCES)
	$(LIBS_PATH) erl -noshell -eval 'edoc:application(amqp_client, ".", [{preprocess, true}])' -run init stop

###############################################################################
##  Testing
###############################################################################

include test.mk

compile_tests: $(TEST_TARGETS) $(EBIN_DIR)/$(PACKAGE).app

$(TEST_TARGETS): $(TEST_DIR)

.PHONY: $(TEST_DIR)
$(TEST_DIR): $(DEPS_DIR)/$(COMMON_PACKAGE_DIR)
	$(MAKE) -C $(TEST_DIR)

###############################################################################
##  Packaging
###############################################################################

COPY=cp -pR

$(DIST_DIR)/$(COMMON_PACKAGE_EZ): $(BROKER_DEPS) $(COMMON_PACKAGE).app | $(DIST_DIR)
	rm -f $@
	$(MAKE) -C $(BROKER_DIR)
	rm -rf $(DIST_DIR)/$(COMMON_PACKAGE_DIR)
	mkdir -p $(DIST_DIR)/$(COMMON_PACKAGE_DIR)/$(INCLUDE_DIR)
	mkdir -p $(DIST_DIR)/$(COMMON_PACKAGE_DIR)/$(EBIN_DIR)
	cp $(COMMON_PACKAGE).app $(DIST_DIR)/$(COMMON_PACKAGE_DIR)/$(EBIN_DIR)/
	$(foreach DEP, $(DEPS), \
	    ( cp $(BROKER_DIR)/ebin/$(DEP).beam $(DIST_DIR)/$(COMMON_PACKAGE_DIR)/$(EBIN_DIR)/ \
	    );)
	cp $(BROKER_DIR)/include/*.hrl $(DIST_DIR)/$(COMMON_PACKAGE_DIR)/$(INCLUDE_DIR)/
	(cd $(DIST_DIR); zip -q -r $(COMMON_PACKAGE_EZ) $(COMMON_PACKAGE_DIR))

source_tarball: $(DIST_DIR)/$(COMMON_PACKAGE_EZ) $(EBIN_DIR)/$(PACKAGE).app | $(DIST_DIR)
	mkdir -p $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/$(DIST_DIR)
	$(COPY) $(DIST_DIR)/$(COMMON_PACKAGE_EZ) $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/$(DIST_DIR)/
	$(COPY) README $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/
	$(COPY) common.mk $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/
	$(COPY) test.mk $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/
	sed 's/%%VSN%%/$(VERSION)/' Makefile.in > $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/Makefile
	mkdir -p $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/$(SOURCE_DIR)
	$(COPY) $(SOURCE_DIR)/*.erl $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/$(SOURCE_DIR)/
	mkdir -p $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/$(EBIN_DIR)
	$(COPY) $(EBIN_DIR)/*.app $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/$(EBIN_DIR)/
	mkdir -p $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/$(INCLUDE_DIR)
	$(COPY) $(INCLUDE_DIR)/*.hrl $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/$(INCLUDE_DIR)/
	mkdir -p $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/$(TEST_DIR)
	$(COPY) $(TEST_DIR)/*.erl $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/$(TEST_DIR)/
	$(COPY) $(TEST_DIR)/Makefile $(DIST_DIR)/$(SOURCE_PACKAGE_DIR)/$(TEST_DIR)/
	cd $(DIST_DIR) ; tar czf $(SOURCE_PACKAGE_TAR_GZ) $(SOURCE_PACKAGE_DIR)

$(DIST_DIR):
	mkdir -p $@

=== plugins-src/rabbitmq-management/Makefile ===
include ../umbrella.mk

RABBITMQCTL=../rabbitmq-server/scripts/rabbitmqctl
TEST_TMPDIR=/tmp/rabbitmq-test


start-second-node:
	rm -f $(TEST_TMPDIR)/rabbitmq-hare-pid
	RABBITMQ_MNESIA_BASE=$(TEST_TMPDIR)/rabbitmq-hare-mnesia \
	RABBITMQ_PID_FILE=$(TEST_TMPDIR)/rabbitmq-hare-pid \
	RABBITMQ_LOG_BASE=$(TEST_TMPDIR)/log \
	RABBITMQ_NODENAME=hare \
	RABBITMQ_NODE_PORT=5673 \
	RABBITMQ_CONFIG_FILE=etc/hare \
	RABBITMQ_PLUGINS_DIR=$(TEST_TMPDIR)/plugins \
	RABBITMQ_PLUGINS_EXPAND_DIR=$(TEST_TMPDIR)/hare-plugins-expand \
	../rabbitmq-server/scripts/rabbitmq-server &
	$(RABBITMQCTL) -n hare wait $(TEST_TMPDIR)/rabbitmq-hare-pid
	$(RABBITMQCTL) -n hare stop_app
	$(RABBITMQCTL) -n hare reset
	$(RABBITMQCTL) -n hare cluster rabbit-test@`hostname -s`
	$(RABBITMQCTL) -n hare start_app

stop-second-node:
	$(RABBITMQCTL) -n hare stop

=== debian/changelog ===
rabbitmq-server (2.7.1-0ubuntu4) precise; urgency=low

  [ Dave Walker ]
  * debian/rabbitmq-script-wrapper: Use start-stop-daemon instead of su
    to run the commands. This also allows rabbitmq to start on the
    installer if invoke-rc.d is used with --force. (LP: #966269)

  [ Andres Rodriguez ]
  * debian/rabbitmq-server.init: Use --no-wait in initctl emit command to
    not stall apt-get installations. (LP: #968124)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 29 Mar 2012 10:46:26 -0400

rabbitmq-server (2.7.1-0ubuntu3) precise; urgency=low

  * debian/rabbitmq-server.init: emit 'rabbitmq-server-running' signal for
    upstart as MAAS needs it.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 27 Mar 2012 14:49:05 -0400

rabbitmq-server (2.7.1-0ubuntu2) precise; urgency=low

  [ Marc Cluet ]
  * Add new rabbitmq-erlang-client and rabbitmq-stomp binary packages as
    plugins are now part of rabbitmq-server core (LP: #948993):
    - d/rules: Refactored to support multiple binary packages, enable
      .d style configuration of rabbitmq for plugins.
    - d/rabbitmq-stomp.[postinst|postrm|install]: Install configuration 
      for stomp, enable/disable stomp plugin and restart as required.
    - d/rabbitmq-erlang-client.[postinst|postrm]: Enable/disable amqp_client
      plugin and restart as required.
    - d/rabbitmq-server.*: Renamed to support multiple binary packages.
    - d/rabbitmq-server.dirs: Added rabbitmq.conf.d dir for .d configuration
      files.
    - d/rabbitmq-server.postrm.in: Avoid deletion of rabbitmq user on purge.
  * Switched to source/format 3.0 (quilt):
    - d/patches/inets-plugins.patch: Fixup path to httpd.hrl.

  [ James Page ]
  * d/control: rabbitmq-server needs to Break/Replace 
    rabbitmq-plugins-common < 2.7.1.
  * d/rabbitmq-server.links: Fixup link to point to 2.7.1 install. 
  * d/rabbitmq-server.init: Restore fix to use start-stop-daemon (LP: #913464).

 -- Marc Cluet <marc.cluet@ubuntu.com>  Mon, 12 Mar 2012 08:58:42 +0000

rabbitmq-server (2.7.1-0ubuntu1) precise; urgency=low

  * New upstream release. (LP: #922600)
  * Apply patch to include inets from the appropriate place. Fixes
    FTBFS.
  * d/control: adding necessary build-deps for 2.7.1

 -- Clint Byrum <clint@ubuntu.com>  Tue, 28 Feb 2012 09:55:49 -0800

rabbitmq-server (2.6.1-1ubuntu4) precise; urgency=low

  * Use start-stop-daemon in the init script, removing usage of su
    (LP: #913464)

 -- Thomas Hervé <thomas.herve@canonical.com>  Fri, 27 Jan 2012 14:58:19 +0100

rabbitmq-server (2.6.1-1ubuntu3) precise; urgency=low

  * Fix broken init script. 

 -- Chuck Short <zulcss@ubuntu.com>  Sun, 13 Nov 2011 22:48:59 -0500

rabbitmq-server (2.6.1-1ubuntu2) precise; urgency=low

  * close file handles of rabbitmq-server daemon in init script (LP: #878600)
  * fix dpkg failure on purge (LP: #878597)

 -- Scott Moser <smoser@brickies.net>  Tue, 25 Oct 2011 12:51:20 -0400

rabbitmq-server (2.6.1-1ubuntu1) precise; urgency=low

  * Merge from debian unstable.  Remaining changes:
    - symlink erlang libraries in a rabbit-common specific location.
    - Added explicit log line in startup_* and shutdown_* (LP: #838959)

 -- Chuck Short <zulcss@ubuntu.com>  Wed, 28 Sep 2011 01:05:54 +0000

rabbitmq-server (2.5.0-1ubuntu2) oneiric; urgency=low

  * Added explicit log line in startup_* and shutdown_* (LP: #838959)
    - Added a log line with a timestamp to indicate either the success or
      failure on startup/shutdown

 -- Marc Cluet <marc.cluet@ubuntu.com>  Wed, 14 Sep 2011 17:56:32 +0200

rabbitmq-server (2.5.0-1ubuntu1) oneiric; urgency=low

  * Merge from Debian Unstable. Remaining changes:
    - symlink erlang libraries in a rabbit-common specific location.

 -- Dave Walker (Daviey) <DaveWalker@ubuntu.com>  Sun, 19 Jun 2011 18:18:49 +0100

rabbitmq-server (2.4.1-1ubuntu2) oneiric; urgency=low

  * Fixed libraries soft link for 2.4.1 release 

 -- Marc Cluet <marc.cluet@ubuntu.com>  Thu, 26 May 2011 02:39:10 -0700

rabbitmq-server (2.4.1-1ubuntu1) oneiric; urgency=low

  * Merge from debian unstable.  Remaining changes:
    - symlink erlang libraries in a rabbit-cmmon specific location.

 -- Chuck Short <zulcss@ubuntu.com>  Mon, 02 May 2011 13:15:56 +0100

rabbitmq-server (2.3.1-1ubuntu1) natty; urgency=low

  * fix rabbitmq-stomp FTBFS, which requires erlang libraries in a
    rabbit-common specific location; solve with a symlink

 -- Dustin Kirkland <kirkland@ubuntu.com>  Tue, 19 Apr 2011 15:32:28 -0400

=== debian/control ===
Source: rabbitmq-server
Section: net
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: RabbitMQ Team <packaging@rabbitmq.com>
Build-Depends: cdbs, debhelper (>= 5), quilt, erlang-dev, python-simplejson, xmlto, xsltproc, git, zip, unzip, erlang-asn1, erlang-inets
Standards-Version: 3.9.3

Package: rabbitmq-server
Architecture: all
Breaks: rabbitmq-plugins-common (<< 2.7.1)
Replaces: rabbitmq-plugins-common (<< 2.7.1)
Depends: erlang-nox (>= 1:12.b.3), adduser, logrotate, ${misc:Depends}
Description: An AMQP server written in Erlang
 RabbitMQ is an implementation of AMQP, the emerging standard for high
 performance enterprise messaging. The RabbitMQ server is a robust and
 scalable implementation of an AMQP broker.
Homepage: http://www.rabbitmq.com/

Package: rabbitmq-erlang-client
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, rabbitmq-server (= ${binary:Version})
Description: Erlang client for RabbitMQ
 This client offers both a networked version that uses standard TCP-based AMQP
 framing and a direct client that uses native Erlang message passing to a
 RabbitMQ broker.

Package: rabbitmq-stomp
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, rabbitmq-server (>= 2.7.1), 
         rabbitmq-erlang-client (= ${binary:Version})
Suggests: ruby
Description: A STOMP gateway for RabbitMQ
 Gateway for exposing AMQP functionality via the STOMP protocol, as
 implemented by many clients for various programming languages, and a few other
 servers besides RabbitMQ.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

MULTIPACKAGE_DEB_DESTDIR=debian/rabbitmq-server/

RABBIT_LIB=$(MULTIPACKAGE_DEB_DESTDIR)usr/lib/rabbitmq/lib/rabbitmq_server-$(DEB_UPSTREAM_VERSION)/
RABBIT_BIN=$(MULTIPACKAGE_DEB_DESTDIR)usr/lib/rabbitmq/bin/

DEB_MAKE_INSTALL_TARGET := install TARGET_DIR=$(RABBIT_LIB) SBIN_DIR=$(RABBIT_BIN) MAN_DIR=$(MULTIPACKAGE_DEB_DESTDIR)usr/share/man/
DEB_MAKE_CLEAN_TARGET:= distclean

DOCDIR=$(MULTIPACKAGE_DEB_DESTDIR)usr/share/doc/rabbitmq-server/

install/rabbitmq-server::
	mkdir -p $(DOCDIR)
	rm $(RABBIT_LIB)LICENSE* $(RABBIT_LIB)INSTALL*
	for script in rabbitmqctl rabbitmq-server; do \
		install -p -D -m 0755 debian/rabbitmq-script-wrapper $(MULTIPACKAGE_DEB_DESTDIR)usr/sbin/$$script; \
	done
	sed -e 's|@RABBIT_LIB@|/usr/lib/rabbitmq/lib/rabbitmq_server-$(DEB_UPSTREAM_VERSION)|g' <debian/rabbitmq-server.postrm.in >debian/rabbitmq-server.postrm
	install -p -D -m 0755 debian/rabbitmq-server.ocf $(MULTIPACKAGE_DEB_DESTDIR)usr/lib/ocf/resource.d/rabbitmq/rabbitmq-server
	install -p -m 0644 debian/conf/rabbitmq-env.conf $(MULTIPACKAGE_DEB_DESTDIR)etc/rabbitmq
